import greenfoot.*;

/** creates a land-roving vehicle */
public class Buggy extends Actor
{
    Wheel[] wheels = new Wheel[2]; // the wheels for the vehicle
    
    /** constructs a vehicle */
    public Buggy()
    {
        GreenfootImage image = new GreenfootImage(40, 10);
        image.fill();
        setImage(image);
        wheels[0] = new Wheel();
        wheels[1] = new Wheel();
    }
    
    /** add the wheels into the world with this vehicle */
    protected void addedToWorld(World w)
    {
        w.addObject(wheels[0], getX(), getY());
        w.addObject(wheels[1], getX(), getY());
        positionWheels();
    }
    
    /**
     * position wheels under buggy, have them find ground and adjust the angle and positional height of buggy
     */
    private void positionWheels()
    {
         for (int num=0; num<2; num++)
        {
            wheels[num].setLocation(getX(), getY());
            wheels[num].setRotation(getRotation());
            wheels[num].move(num*24-12);
            wheels[num].turn(90);
            wheels[num].move(12);
            wheels[num].fall();
        }
        int ang = (int)(Math.atan2(wheels[1].getY()-wheels[0].getY(), wheels[1].getX()-wheels[0].getX())*180/Math.PI);
        setRotation(ang);
        setLocation(getX(), (wheels[0].getY()+wheels[1].getY())/2-15);
    }

    /**
     * give buggy user control with left/right arrow keys
     */
    public void act()
    {
        int dx = 0;
        if (Greenfoot.isKeyDown("left")) dx--;
        if (Greenfoot.isKeyDown("right")) dx++;
        if (dx == 0 || getX()+dx >= 580 || getX()+dx < 20) return;
        move(2*dx);
        positionWheels();
    }

    /** **************************    Class:  Wheel    ************************ */
    public class Wheel extends Actor
    {
        /** constructs a wheel */
        public Wheel()
        {
            GreenfootImage image = new GreenfootImage(13, 13);
            image.fillOval(0, 0, 12, 12);
            setImage(image);
        }
        
        /**
         * keeps wheels firmly planted on the ground
         */
        public void fall()
        {
            while (getWorld().getBackground().getColorAt(getX(), getY()+8).equals(Color.WHITE))
            {
                setLocation(getX(), getY()+1);
            }
            while (!getWorld().getColorAt(getX(), getY()+8).equals(Color.WHITE))
            {
                setLocation(getX(), getY()-1);
            }
        }
    }
}