import greenfoot.*;

public class View extends World
{
    /** ******************   ADD FIELD   ******************  */
    Scroll scroll; // you need this line here
    /** ***************************************************  */
    Actor main; // you should have a reference to your main actor here
    
    public View()
    {
        super(600, 400, 1, false); // use the 'false' here; so objects can scroll outside the view
        GreenfootImage bgImage = getScrollBg(); // create the GreenfootImage for your background here
        /** *******************   ASSIGN FIELD   ******************** */
        scroll  = new Scroll(bgImage, this); // create your Scroll world object
        /** ********************************************************* */
        main = new Buggy(); // create the main actor
        addObject(main, 25, 270); // add main actor into the world
    }
    
    // creates a large (2000 px wide) image of rough terrain for the background
    private GreenfootImage getScrollBg()
    {
        java.util.Random rand = new java.util.Random(14);
        GreenfootImage bg = new GreenfootImage(2000, 400);
        bg.setColor(Color.WHITE);
        bg.fill();
        bg.setColor(new Color(224, 192, 144));
        int h = 350;
        for (int x=0; x<bg.getWidth(); x+=5)
        {
            int chg = rand.nextInt(21)-10;
            while (h+chg >= getHeight()) chg--;
            for (int n=0; n<5; n++) bg.drawLine(x+n, h+(chg*n/5), x+n, bg.getHeight());
            h += chg;
        }
        bg.scale(bg.getWidth()*3, 400);
        return bg;
    }
    
    /** scrolls the world background */
    public void act()
    {
        scroll(); // you need this line here
    }
    
    /**
     * you need this method (or the one commented out below; however, the
     * content can be altered to suit your scenario; it determines if you
     * need to scroll and must contain the 'for' loop and the line before
     * it; it can be made to restrict the scrolling of specific classes
     * using the 'instanceof' keyword on 'actor' to determine whether it
     * is of a class that scrolls.
     */
    /** scrolls up to scrolling limits if buggy is within 80 pixels of side edge */
    public void scroll()
    {
        int limitX = 80; // how close the main actor can get to side edges of world
        int ds = main.getX(); // get x of your main actor here
        if (ds >= limitX && ds <= getWidth()-limitX) return; // no need to scroll
        if (ds > getWidth()-limitX) ds -= getWidth()-limitX*2;
        ds -= limitX; // this and previous line alter ds to the required change in scroll amount
        /** *********************   SCROLL BACKGROUND   ********************** */
        int scrolledAmt = scroll.changeScrollX(ds); // scrolling the background
        /** ****************************************************************** */
        // the following loop scrolls the actors by the same amount the background scrolled
        for (Object obj : getObjects(null)) // scrolling the actors
        {
            Actor actor = (Actor)obj;
            // /** to prevent certain actor types from scrolling */
            // if (actor instanceof Score.class || actor instanceof Health.class) continue;
            // /** to allow only specific actor types to scroll */
            // if (actor instanceof Buggy.class && actor instanceof Wheel.class)
            actor.setLocation(actor.getX()-scrolledAmt, actor.getY());
        }
    }
    
    /**
     * I included the following method to show how a universal scroller can be
     * controlled. For a vertical scroller, make the appropriate changes in the
     * 'scroll' method above.
     */
    //     public void scroll()
    //     {
    //         int dsx = main.getX();
    //         if (dsx >= 40 && dsx <= getWidth()-40) dsx = 0; else
    //         {
    //             if (dsx > getWidth()-40) dsx -= getWidth()-40*2;
    //             dsx -= 40;
    //         }
    //         int dsy = main.getY();
    //         if (dsy >= 40 && dsy <= getHeight()-40) dsy = 0; else
    //         {
    //             if (dsy > getHeight()-40) dsy -= getHeight()-40*2;
    //             dsy -= 40;
    //         }
    //         if (dsx == 0 && dsy == 0) return;
    //         int[] scrolledAmts = scroll.changeScroll(dsx, dsy);
    //         for (Object obj : getObjects(null))
    //         {
    //             Actor actor = (Actor)obj;
    //             // if (actor instanceof Text && actor instanceof Counter) continue;
    //             actor.setLocation(actor.getX()-scrollAmts[0], actor.getY()-scrollAmts[1]);
    //         }
    //     }        
}